package com.helicon.sysanalyzer;

/**
 * This class provides the method which go throw the specified directory
 * @author Vladimir Koval
 * @author (c) 2002 Helicon, Ukraine
 */
public class DirCycle {

        private String rootDir = null;
        private ZipCreate zc;
      

/**
 *  Creates a new instance of the DirCycle class
 **/
public DirCycle(){
	super();
	zc = new ZipCreate();
	
}
/**
 *  Creates a new instance of the DirCycle class
 * @param outputPath String the name of output file
 * @param verbose boolean the verbose mode on
 **/
public DirCycle(String outputPath, boolean verbose, String dateRootDir){
	super();
	rootDir = outputPath;
	zc = new ZipCreate(rootDir, verbose, dateRootDir);

	
}

/**
* The method for finall events
**/
public void finallyMethod(){

	zc.finallyMethod();

}	


/**
 * Goes throw the specified directory
 * @param dirpath path to directory
 * @exception java.io.IOException if an I/O error occurs
 */             
public String getDir(String dirpath) throws java.io.IOException {
     java.io.File curr_dir = new java.io.File(dirpath);
     String s[] = curr_dir.list();
     String ret = null;

     if (s == null){
			zc.zipCreate(curr_dir.getPath());	
			return ret; 
	 }

    
     for (int i = 0; i < s.length;i++){
        String inputDir = dirpath;
        String cDir = dirpath + "/" + s[i];

         java.io.File f = new java.io.File(cDir);
         if (f.isDirectory()){
           getDir(cDir);
         } else {

			zc.zipCreate(f.getPath());
         }
     }

     return ret;

}
}
