package com.helicon.sysanalyzer;

import java.util.*;
//import java.util.zip;
//import java.util.jar;

/** The additional class for creating proper list of output files and directories
 *
 * @author Vladimir Koval &lt;<a href="mailto:kovvl@yahoo.com">kovvl@yahoo.com</a>&gt;
 * @author (c) 2002 Helicon, Ukraine www.helicon.com.ua
 */
public class DirInfo {

    // delimiter of inputed directories
    private String delimiter = ";";
    // body with html tegs
    StringBuffer sbody = new StringBuffer();

    //directories and files
    java.util.TreeMap ht = new java.util.TreeMap();
    //directories and files for output
    java.util.TreeMap htOut = new java.util.TreeMap();
    // system information
    java.util.TreeMap tmSystemOut = new java.util.TreeMap();
    java.util.TreeMap tmListsJar = new java.util.TreeMap();
    private java.util.ArrayList contains = new java.util.ArrayList();
    // all files
    java.util.ArrayList containsObjectFilesAll = new java.util.ArrayList();
    // repeated files
    java.util.ArrayList contRepFiles = new java.util.ArrayList();

    java.util.ArrayList alListAllContentJar = new java.util.ArrayList();
    java.util.ArrayList alListAllJars = new java.util.ArrayList();

    //    java.util.TreeMap tmListAllContentJar = new java.util.TreeMap();
    java.util.Hashtable htListAllContentJar = new java.util.Hashtable();

    java.util.ArrayList contRepeatedContentJar = new java.util.ArrayList();

    // current number of directory
    public int currCount = 0;

    private boolean contentsJar = false;
    private boolean contentsZip = false;

    private org.apache.regexp.RECompiler rc = new org.apache.regexp.RECompiler();
    private org.apache.regexp.RE re = new org.apache.regexp.RE();
    private org.apache.regexp.REProgram rp = null;

    /**
     * Checking for equal
     **/
    public DirInfo(boolean contentsJar, boolean contentsZip) {
        this.contentsJar = contentsJar;
        this.contentsZip = contentsZip;

    }
    public DirInfo() {
    }

    public void checkForEqual(java.io.File f) {

        if (this.contains.contains(f.getName())) {
            this.contRepFiles.add(f.getName());

        } //end if
    }

    public void checkForRepeatedContentJar(java.util.jar.JarEntry currEntry) {

        if (this.alListAllContentJar.contains(currEntry.getName())) {
            this.contRepeatedContentJar.add(currEntry.getName());

        } //end if
    }

    /**
     * Filling java.util.TreeMap with proper files for output
     * <p>
     * @param br java.io.BufferedReader
     *
     * @param exceptDirs lava.lang.String
     * @param exceptFiles lava.lang.String
     * @param exceptExts lava.lang.String
     */
    public void FillingBody(
        java.io.BufferedReader br,
        String exceptDirs,
        String exceptFiles,
        String exceptExts,
        String onlyExts,
        String onlyNames) {

        String key = null;

        java.io.File file = null;
        java.util.ArrayList al = new java.util.ArrayList();

        java.util.Iterator iter = null;
        iter = ht.keySet().iterator();

        java.util.ArrayList net = new java.util.ArrayList();
        java.util.ArrayList alBan = new java.util.ArrayList();
        java.util.ArrayList netFiles = new java.util.ArrayList();
        java.util.ArrayList netOnlyExts = new java.util.ArrayList();
        java.util.ArrayList netOnlyNames = new java.util.ArrayList();

        java.util.ArrayList alBanList = new java.util.ArrayList();

        String ext = null;
        String clearDir = null;
        int point = 0;
        int slashInt = 0;
        boolean first = false;
        boolean dirExit = false;
        boolean netExit = false;

        StringTokenizer token = null;

        // filling java.util.ArrayList excepting well-defined directories
        if (exceptDirs != null) {

            token = new StringTokenizer(exceptDirs, this.delimiter);
            while (token.hasMoreTokens()) {
                alBan.add(token.nextToken().trim());
            }
        }
        // filling java.util.ArrayList excepting well-defined files
        if (exceptFiles != null) {
            token = new StringTokenizer(exceptFiles, this.delimiter);
            while (token.hasMoreTokens()) {
                netFiles.add(token.nextToken().trim());
            }
        }

        // filling java.util.ArrayList excepting well-defined extensions
        if (exceptExts != null) {
            token = new StringTokenizer(exceptExts, this.delimiter);
            while (token.hasMoreTokens()) {
                String nextToken = token.nextToken().trim();
                int pointInt = nextToken.indexOf(".", 0);
                if (pointInt != -1) {
                    nextToken = nextToken.substring(point + 2, nextToken.length());
                }

                net.add(nextToken);
            }
        }

        // filling java.util.ArrayList only well-defined extensions
        if (onlyExts != null) {
            token = new StringTokenizer(onlyExts, this.delimiter);
            while (token.hasMoreTokens()) {
                String nextToken = token.nextToken().trim();
                int pointInt = nextToken.indexOf(".", 0);
                if (pointInt != -1) {
                    nextToken = nextToken.substring(point + 2, nextToken.length());
                }

                netOnlyExts.add(nextToken);
            }
        }
        /*
                // filling java.util.ArrayList only well-defined extensions
                if (onlyExts != null) {
                    token = new StringTokenizer(onlyExts, this.delimiter);

                    while (token.hasMoreTokens()) {
                        netOnlyExts.add(token.nextToken().trim());
                    }
                }
        */
        // filling java.util.ArrayList only well-defined names
        if (onlyNames != null) {
            token = new StringTokenizer(onlyNames, this.delimiter);

            while (token.hasMoreTokens()) {
                netOnlyNames.add(token.nextToken().trim());
            }
        }

        //
        if (exceptFiles != null) {
            token = new StringTokenizer(exceptFiles, this.delimiter);
            while (token.hasMoreTokens()) {
                netFiles.add(token.nextToken().trim());
            }
        }

        //

        //retrieve all the directories
        java.util.Iterator en = ht.keySet().iterator();

        //    this.sbody = HTMLProducerBegTable(this.sbody);

        // filling java.util.TreeMap with correct directories and files
        for (int i = 0; iter.hasNext(); i++) {

            // al out
            java.util.ArrayList alOut = new java.util.ArrayList();

            // name of directory
            key = (java.lang.String) iter.next();

            first = true;
            dirExit = false;

            //slashInt = key.lastIndexOf("\\");
            slashInt = key.lastIndexOf(java.io.File.separator);
            clearDir = key.substring(slashInt + 1, key.length());

/////
                    if (alBan.size() != 0)
                        dirExit = false;
                    for (int n = 0; n < alBan.size(); n++) {
                        if (searchMaske((String) alBan.get(n), key)) {
                            dirExit = true;
                        }//end if
                    }// end for
                    if (dirExit)
                        continue;

/////
/*            // for directories for ignore
            for (int b = 0; b < alBan.size(); b++) {
                // if ban equals to name of directory
                if (clearDir.equals(alBan.get(b))) {
                    alBanList.add(key);
                    dirExit = true;
                } else {
                    for (int s = 0; s < alBanList.size(); s++) {
                        if (key.startsWith((String) alBanList.get(s))) {
                            dirExit = true;
                        } //end if
                    } //end for
                    //					if (key.indexOf("\\"+alBan.get(b)+"\\") != -1){
                    if (key.indexOf(java.io.File.separator + alBan.get(b) + java.io.File.separator)
                        != -1) {
                        dirExit = true;
                    }

                } // end if

            } //end for

            if (dirExit)
                continue;
*/
            // All the files in that directory
            al = (java.util.ArrayList) ht.get(key);
            for (int j = 0; j < al.size(); j++) {

                // for files' extensions
                netExit = false;
                file = (java.io.File) al.get(j);
                //difinition of extension
                point = file.getName().lastIndexOf(".");
                ext = file.getName().substring(point + 1, file.getName().length());

                boolean includeJar = false;

                // if checkBox jar is checked
//                if ((contentsJar) || (contentsZip)) {
                    //if (ext.equals("jar") || ext.equals("zip")) {
                if ((ext.equals("jar") && contentsJar) || (ext.equals("zip") && contentsZip)) {

                        // checking in accordance with netOnlyNames ONLY with such dir's and file's name
                        if (netOnlyNames.size() != 0) {

                            for (int n = 0; n < netOnlyNames.size(); n++) {

                                String currOnlyFile = (String) netOnlyNames.get(n);
                                // check for according maskName in content of jar file
                                includeJar = checkForEqualJar(file.getAbsolutePath(), currOnlyFile);

                            } //end for
                        } //end if

                    } //end if
//                } //end if

                // checking in accordance with netOnlyExts ONLY with such file's extension
/*                if (!includeJar) {
                    if (netOnlyExts.size() != 0)
                        netExit = true;
                    for (int n = 0; n < netOnlyExts.size(); n++) {
                        if (ext.equals(netOnlyExts.get(n))) {
                            netExit = false;
                        }
                    }
                    if (netExit)
                        continue;
*/
                    // checking in accordance with netOnlyNames ONLY with such dir's and file's name
                    if (netOnlyNames.size() != 0)
                        netExit = true;
                    for (int n = 0; n < netOnlyNames.size(); n++) {
                        if (searchMaske((String) netOnlyNames.get(n), file.getAbsolutePath()))
                            netExit = false;
                          /*
                                                int include = file.getAbsolutePath().lastIndexOf((String) netOnlyNames.get(n));
                                                if (include != -1) {
                                                    //					if (!file.getAbsolutePath().equals(netOnlyNames.get(n))){
                                                    netExit = false;
                                                }
                        */
                    }// end for

                    if (netExit)
                        continue;
////
                    if (alBan.size() != 0)
                        netExit = false;
                    for (int n = 0; n < alBan.size(); n++) {
                        if (searchMaske((String) alBan.get(n), file.getAbsolutePath())) {
                            netExit = true;
                        }//end if
                    }// end for

////
/*                // checking in accordance with net file's extension
                for (int n = 0; n < net.size(); n++) {
                    if (ext.equals(net.get(n))) {
                        netExit = true;
                    }
                }
                // checking in accordance with net file's name
                for (int n = 0; n < netFiles.size(); n++) {
                    if (file.getName().equals(netFiles.get(n))) {
                        netExit = true;
                    }
                }
*/
                if (first) {
                    //		            this.sbody = HTMLProducerDir(this.sbody, key);

                    htOut.put(key, alOut);

                    first = false;
                } //end if
                if (!netExit) {
                    //					sbody = HTMLProducerBody(sbody, file);

                    //checking for equal files
                    checkForEqual(file);

                    alOut = (java.util.ArrayList) htOut.get(key);
                    // add file to java.util.TreeMap
                    alOut.add(file);

                    this.contains.add(file.getName());
                    this.containsObjectFilesAll.add(file);

                } //end if

            } //end for
        } //end for
        //    this.sbody = HTMLProducerEndTable(this.sbody);

    }

    public void fillListForJar(java.io.File file) {

        String ext = null;
        int point = 0;

        //difinition of extension
        point = file.getName().lastIndexOf(".");
        ext = file.getName().substring(point + 1, file.getName().length());

        if ((ext.equals("jar") && contentsJar) || (ext.equals("zip") && contentsZip)) {
 //       if (ext.equals("jar") || ext.equals("zip")) {
	        alListAllJars.add(file);
            try {
                java.util.jar.JarFile jarFile = new java.util.jar.JarFile(file);

                //  java.util.jar.ZipEntry jarFile = new java.util.jar.ZipEntry(file);

                //                String timeNameJar = jarFile.entries().nextElement().toString();
                //	            java.util.jar.JarEntry timeEntry = jarFile.entries().nextElement().toString;

                java.util.ArrayList alListJar = new java.util.ArrayList();
                tmListsJar.put(file.getAbsolutePath(), alListJar);

                for (Enumeration e = jarFile.entries(); e.hasMoreElements();) {

                    alListJar = (java.util.ArrayList) tmListsJar.get(file.getAbsolutePath());

                    java.util.jar.JarEntry currEntry =
                        jarFile.getJarEntry(e.nextElement().toString());
                    // add file to java.util.TreeMap

                    //String timeNameJar = jarFile.entries().nextElement().toString();

                    //                    alListJar.add(e.nextElement());
                    alListJar.add(currEntry);
                    // check for last "/"
                    //if (currEntry.getName().endsWith(java.io.File.separator)){

                    // for jar contents
                    if (ext.equals("jar") && (currEntry.getName().endsWith("/"))) {
                        continue;
                    } //end if

                    //String getName = currEntry.getName() ;

//                    System.out.println("Type of currEntry" + currEntry);

                    //java.util.TreeMap timetmListAllContentJar = tmListAllContentJar ;

                    //htListAllContentJar.put(currEntry, jarFile);
                    htListAllContentJar.put(currEntry, file);
                    checkForRepeatedContentJar(currEntry);
                    alListAllContentJar.add(currEntry.getName());

                }

                //java.util.jar.JarEntry entry = new java.util.jar.JarEntry(file);
                //             zip.putNextEntry(entry);
            } catch (Exception ex) {
                System.out.println(ex);
            }

        }

    }
    /**
     * Filling HashTable with data about name of directories and included
     * files
     * @param dirpath path to directory
     * @exception java.io.IOException if an I/O error occurs
     */
    public void getDir(String dirpath) throws java.io.IOException {

        java.io.File curr_dir = new java.io.File(dirpath);
        String s[] = curr_dir.list();
        boolean chedDir = true;

        java.util.ArrayList al = new java.util.ArrayList();
        java.util.ArrayList contains = new java.util.ArrayList();
        Object key = new Object();

        if (s == null) {

            System.out.println("There is no folder with the entered name");

            throw new java.io.IOException();
        }

        for (int i = 0; i < s.length; i++) {
            String inputDir = dirpath;
            String cDir = dirpath + "/" + s[i];

            // checking for ban
            java.io.File f = new java.io.File(cDir);
            if (f.isDirectory()) {
                getDir(cDir);
                chedDir = true;

            } else {

                if (chedDir) {
                    System.out.print("(" + currCount + " dirs) ");
                    System.out.println(f.getParent());
                    currCount++;
                    // add name of dirrectory
                    ht.put(f.getParent(), al);
                };

                key = f.getParent();
                al = (java.util.ArrayList) ht.get(key);
                // add file
                al.add(f);


                if ((contentsJar) || (contentsZip)) {
                    fillListForJar(f);
                }

                chedDir = false;
            }
        }
    }
    /**
     * Filling StringBuffer with information for creating HTML file
     * Creating HTML file
     *
     * @exception java.io.IOException if an I/O error occurs
     */
    public void HTMLProducer(String outputDir) {

        StringBuffer sb = new StringBuffer();

        String rootDir = "." + java.io.File.separator;

        java.util.Date myDate = new java.util.Date();
        String currentData =
            java
                .text
                .DateFormat
                .getDateTimeInstance(
                    java.text.DateFormat.LONG,
                    java.text.DateFormat.SHORT,
                    Locale.ENGLISH)
                .format(myDate);

        sb.append("<HTML>\n");
        sb.append("<HEAD>\n");

        sb.append("<TITLE>\n");
        sb.append("System Info");
        sb.append("</TITLE>\n");

        sb.append(
            "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

        sb.append("</HEAD>\n");
        sb.append("<BODY>\n");

        sb.append(
            "<p align=\"center\"><font color=\"#004080\"><big><big><big>Report for "
                + currentData
                + "</big></big></big></font></p>");

        sb.append(this.sbody);

        sb.append("</BODY>\n");
        sb.append("</HTML>\n");

        System.out.println(
            "HTML file with System information was created successfully");
        System.exit(1);

    }
    /**
     * Filling StringBuffer with tags about begining table
     *
     * @param sb java.lang.StringBuffer
     * @return java.lang.StringBuffer
     */
    public StringBuffer HTMLProducerBegTable(StringBuffer sb) {

        sb.append("\n<table width=\"90%\">\n");
        sb.append("<tr>");

        sb.append("<td  width=\"75%\">");
        sb.append("<strong><font color=\"#004080\">Files</font></strong>");
        sb.append("</td>");

        sb.append("<td  width=\"25%\">");
        sb.append("<strong><font color=\"#008080\">Bytes</font></strong>");
        sb.append("</td>");

        sb.append("</tr>\n");

        return sb;

    }
    /**
     * Filling StringBuffer with tags and information about files
     *
     * @param sb java.lang.StringBuffer
     * @param f java.io.File
     *
     * @return java.lang.StringBuffer
     */
    public StringBuffer HTMLProducerBody(StringBuffer sb, java.io.File f) {

        sb.append("<tr>");

        sb.append("<td>");

        if (this.contains.contains(f.getName())) {
            sb.append("<font color=\"#FF0000\">");
            this.contRepFiles.add(f.getName());

        } else {
            sb.append("<font color=\"#004080\">");
        }

        sb.append(f.getName());
        sb.append("</font>");
        sb.append("</td>");

        sb.append("<td>");
        sb.append("<p align=\"left\">");
        sb.append("<font color=\"#008080\">");
        sb.append(f.length());
        sb.append("");

        sb.append("</font>");
        sb.append("</td>");

        sb.append("</tr>\n");

        return sb;

    }
    /**
     * Filling StringBuffer with tags and information about name of directories
     *
     * @param sb java.lang.StringBuffer
     * @param namedir java.lang.String
     *
     * @return java.lang.StringBuffer
     */
    public StringBuffer HTMLProducerDir(StringBuffer sb, String namedir) {

        sb.append("<tr>");

        sb.append("<td>");
        sb.append("<font color=\"#0000FF\">");
        sb.append(namedir);
        sb.append("</font>");

        sb.append("</td>");

        sb.append("<td>");
        sb.append("</td>");

        sb.append("</tr>\n");

        return sb;

    }
    /**
     * Filling StringBuffer with tags about end of table
     *
     * @param sb java.lang.StringBuffer
     * @return java.lang.StringBuffer
     */
    public StringBuffer HTMLProducerEndTable(StringBuffer sb) {

        sb.append("</table>\n");
        return sb;

    }
    /**
     * Filling StringBuffer with tags and information about Java system information
     *
     * @param sb java.lang.StringBuffer
     *
     * @return java.lang.StringBuffer
     */
    public StringBuffer HTMLProducerJava(StringBuffer sb) {

        sb.append("<table width=\"90%\">");

        sb.append("<tr width=\"60%\">");

        sb.append("<td>");
        sb.append("<font color=\"#0000FF\">");
        sb.append("Java class path");
        sb.append("</font>");

        sb.append("</td>");

        sb.append("<td width=\"40%\">");
        sb.append(java.lang.System.getProperty("java.class.path"));
        sb.append("</td>");

        sb.append("</tr>\n");

        sb.append("</table>");
        return sb;

    }
    /**
     * Filling StringBuffer with tags and information about System information
     *
     * @param sb java.lang.StringBuffer
     * @param br java.io.BufferedReader
     *
     * @return java.lang.StringBuffer
     */
    public StringBuffer HTMLProducerSystem(
        StringBuffer sb,
        java.util.ArrayList br) {

        String line = null;
        String variable = null;
        String value = null;
        sb.append("<b>");
        sb.append("<font size=\"4\" color=\"#000080\">");
        sb.append("Environment Variables :");
        sb.append("</font>");
        sb.append("</b>");

        sb.append("<table>");

        sb.append("<tr>");
        sb.append("<td>");

        sb.append("<font color=\"#000080\">");

        try {
            for (int i = 0; i < br.size(); i++) {
                line = (String) br.get(i);
                int eq = line.indexOf("=");
                variable = line.substring(0, eq);
                value = line.substring(eq, line.length());

                // filling java.util.TreeMap with system information
                tmSystemOut.put(variable, value.substring(1, value.length()));

                sb.append("<font color=\"#0000FF\">");
                sb.append(variable);
                sb.append("</font>");

                sb.append("<font color=\"#000080\">");
                sb.append(value);
                sb.append("</font>");

                sb.append("<br>");
            }

        } catch (Throwable t) {
            t.printStackTrace();
        }

        sb.append("</font>");

        sb.append("</td>");
        sb.append("<td>");
        sb.append("<p align=\"left\">");
        sb.append("<font color=\"#008080\">");
        sb.append("");

        sb.append("</font>");
        sb.append("</td>");

        sb.append("</tr>\n");

        sb.append("</table>");
        return sb;

    }
    public boolean checkForEqualJar(String fileName, String fileNameMask) {

        java.util.Iterator iter = null;
        boolean includeJar = false;

        //        String key = null;
        java.util.ArrayList alContentJar = new java.util.ArrayList();

        //        iter = this.tmListsJar.keySet().iterator();

        // throw lists of class and manifest files
        //        while (iter.hasNext()) {

        //            includeJar = false;
        //        for (int i = 0; iter.hasNext(); i++) {

        //            key = (String) iter.next();

        alContentJar = (java.util.ArrayList) this.tmListsJar.get(fileName);

        for (int b = 0; b < alContentJar.size(); b++) {

            java.util.jar.JarEntry currEntry = (java.util.jar.JarEntry) alContentJar.get(b);

            String currInJarFile = currEntry.getName();

            int dollar = currInJarFile.lastIndexOf("$");
            if (dollar != -1) {
                int point = currInJarFile.indexOf(".");
                String cutText = currInJarFile.substring(dollar, point);
                currInJarFile = replace(currInJarFile, cutText, "");
            }

            //		                    int include = file.getAbsolutePath().lastIndexOf((String) netOnlyNames.get(n));
            if (searchMaske(fileNameMask, currInJarFile)) {
                includeJar = true;
                continue;
            }
            /*
                            int include = currInJarFile.lastIndexOf(fileNameMask);
                            if (include != -1) {
                                includeJar = true;
                                continue;
                            } //end if
            */

        } //end for
        //        }
        return includeJar;

    }
    private String matchSingle(String text, String regexp) {
        try {
            re.setMatchFlags(
                org.apache.regexp.RE.MATCH_CASEINDEPENDENT
                    | org.apache.regexp.RE.MATCH_MULTILINE);
            rp = rc.compile(regexp);
            re.setProgram(rp);
            if (re.match(text)) {
                return re.getParen(1);
            }
        } catch (Exception ex) {
            System.err.println("regexp " + regexp + " error --> " + ex);
        }
        return "";
    }

    public boolean searchMaske(String masketext, String nameFile) {

        boolean matched = false;

        if (masketext != null
            && masketext.length() > 0
            && nameFile != null
            && nameFile.length() > 0) {

            masketext = replace(masketext, ".", "\\.");
            masketext = replace(masketext, "*", ".*");
            masketext = replace(masketext, "?", ".?");
//            masketext = replace(masketext, "?", ".{1}");
           // masketext = replace(masketext, ".", ".{1}");

            try {

                // * = .*
                // ? = .?
                // . = .{1}

                org.apache.regexp.RE r = new org.apache.regexp.RE(masketext);
                matched = r.match(nameFile);

            } catch (org.apache.regexp.RESyntaxException reex) {
                System.err.println("regexp error --> " + reex);
            }
        }
        System.out.println(matched);
        return matched;
        /*
            if (masketext != null && masketext.length() > 0) {
                //<!--   VNR  12345678  -->
                //<rx:regexp id="rx3">m/\sVNR\s*([\d\w]{1,8})/mi</rx:regexp>
                //			KDVersNr = matchSingle(masketext, "^ VNR\\s+(\\w+)").trim();  //"^ VNR  (.+?)\\s+?"
                String ttt = matchSingle(masketext, "^ \\s+(\\w+)").trim();
                //System.out.println("KDVersNr = <" + KDVersNr + ">");
                //<!--   Name            Max                            Mueller  -->
                // <rx:regexp id="rx4">m/\sName ([\w\.|\s]{1,10}) ([\w|\s]{1,30}) ([\w|\s]{1,30})/mi</rx:regexp>
                try {
                    //rp = rc.compile("^ Name ([\\w\\.|\\s]{1,10}) ([\\w|\\s]{1,30}) ([\\w|\\s]{1,30})");
                    rp = rc.compile("^ Name \\w+");
                    re.setMatchFlags(
                        org.apache.regexp.RE.MATCH_CASEINDEPENDENT
                            | org.apache.regexp.RE.MATCH_MULTILINE);
                    re.setProgram(rp);
                    if (re.match(masketext)) {
                        String t2 = re.getParen(1).trim();
                        //					KDNachname = re.getParen(2).trim();
                        //					KDVorname = re.getParen(3).trim();
                    }
                } catch (org.apache.regexp.RESyntaxException reex) {
                    System.err.println("regexp for KDTitel error --> " + reex);
                }
                //<!-- Geburtsdatum 13 05 1961            Geschlecht M      Fam.St. 2      StKl. 3 -->
                // <rx:regexp id="rx5">m/\sGeburtsdatum\s*([\d]{1,2}\s[\d]{1,2}\s[\d]{1,4})\s*Geschlecht\s*([M|W])\s*Fam\.St\.\s*([0-9])\s*StKl\.\s*([0-9])/mi</rx:regexp>
                //			geb1 = replace(matchSingle(masketext, "^ Geburtsdatum\\s+(\\d{1,2} \\d{1,2} \\d{1,4}) "), " ", ".");
                //			gp1 = ("1".equalsIgnoreCase(matchSingle(masketext, " Geschlecht\\s+([1|2]?)")) ? "0" : "1");
            }
            return true;
        */
    }
    /**
     * Replaces some text with another
     * @param input input string
     * @param search search string
     * @param replace replace string
     * @return changed string
     */
    public String replace(String input, String search, String replace) {

        return (replace(new StringBuffer(input), search, replace));

    }

    /**
     * Replaces some text with another
     * @param buf StringBuffer
     * @param index index to start from
     * @param len length
     * @param replace replace string
     * @return changed StringBuffer
     */
    public StringBuffer replace(
        StringBuffer buf,
        int index,
        int len,
        String replace) {
        return buf.replace(index, (index + len), replace);
    }

    /**
     * Replaces some text with another
     * @param buf StringBuffer
     * @param search search string
     * @param replace replace string
     * @return changed string
     */
    public String replace(StringBuffer buf, String search, String replace) {
        int start = 0;
        int len = search.length();
        int rlen = replace.length();
        int index = buf.toString().indexOf(search, start);
        while (index != -1) {
            int mindex = buf.toString().indexOf(replace, start);

            if (mindex != index)
                buf = replace(buf, index, len, replace);
            else
                if (len > rlen)
                    buf = replace(buf, index + rlen, len - rlen, "");
            start = index + replace.length() + 1;
            if (start > buf.length())
                break;
            index = buf.toString().indexOf(search, start);
        }
        return buf.toString();
    }

}