package com.helicon.sysanalyzer;

//import sun.io.*;
/**rep
 * This class provides the methods to produce HTML pages
 * with the directories and object's content for the console tool
 * Most of the methods take the java.io.PrintWriter object
 * as a parameter and use it for output
 * @author Vladimir Koval &lt;<a href="mailto:kovvl@yahoo.com">kovvl@yahoo.com</a>&gt;
 * @author (c) 2002 Helicon, Ukraine www.helicon.com.ua
 */
public class HTMLProducerConsole {

    private java.util.TreeMap htOut = new java.util.TreeMap();
    private int colFlash = 0;
    private boolean linux;


        /** comparator for reverse sorting by the first column backwards */
    // this here defines the comprator and its implementation in one step
/*    public final static java.util.Comparator comparatorSort = new java.util.Comparator() {
        public int compare(java.lang.String o1, java.lang.String o2) {
//            e2c.db.ViewDataField df1 = ((e2c.db.ViewDataRow) o1).getColumn(0);
//            e2c.db.ViewDataField df2 = ((e2c.db.ViewDataRow) o2).getColumn(0);
            java.lang.String s1 = o1.getString();
            java.lang.String s2 = o2.getString();
            return ((java.lang.Comparable) s2).compareTo(s1);
        }
    };
    */

    /**
    	* Creates the bottom left frame, which contains the list of the links
    	* to all the objects in all the directories
    	* @param out java.io.PrintWriter object to use for output
    	*/

    public void writeAllCatalog(
        java.io.PrintWriter out,
        java.util.TreeMap tmSystemOut) {

        StringBuffer sb = new StringBuffer();
        sb.append("<HTML>\n");
        sb.append("<HEAD>\n");
        sb.append("<TITLE>All system information</TITLE>\n");
        sb.append(
            "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");
        sb.append(
            "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"stylesheet.css\" TITLE=\"Style\">\n");
        sb.append("</HEAD>\n");
        sb.append("<BODY>\n");
        sb.append("<DIV CLASS=IncreasedBold>All system information</DIV>\n");
        sb.append("<P></P>\n");
        sb.append("<P></P>\n");

        sb.append("<DIV CLASS=IncreasedBold>System Variables</DIV>\n");

        java.util.Iterator itvar = tmSystemOut.keySet().iterator();

        //		alDirList
        String currVar = "";

        while (itvar.hasNext()) {

            currVar = (String) itvar.next();

            sb.append("<A href=\".");
            sb.append(java.io.File.separator);
            sb.append("\n");
            sb.append("variables");
            sb.append(java.io.File.separator);
            sb.append(currVar);
            sb.append("_varobjects.html\" TARGET=\"data\">\n");
            sb.append(currVar);
            sb.append("</A><BR>\n");
        }

        sb.append("</DIV>\n");
        sb.append("</BODY>\n");
        sb.append("</HTML>\n");
        out.println(sb.toString());
        out.flush();
        out.close();
    }

    /**
    	* Produces HTML document with the content of all files for
    	* the all specified directories
    	* @param out java.io.PrintWriter object to use for output
    	* @param containsFiles java.util.ArrayList the list of all Dublicated names of the all files contained in the all directories
    	* @param alAllFiles java.util.ArrayList the list of all names of the all files contained in the all directories
    	*/

    public void writeAllFilesContent(
        java.io.PrintWriter out,
        java.util.ArrayList containsFiles,
        java.util.ArrayList alAllFiles) {

        int j;
        long n = 0;
        boolean curBG;
        StringBuffer sb = new StringBuffer();

        sb.append("<HTML>\n");
        sb.append("<HEAD>\n");
        sb.append("<TITLE>\n");
        sb.append(" ");
        sb.append(" content");
        sb.append("</TITLE>\n");
        sb.append(
            "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

        sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

        sb.append("../");

        sb.append("stylesheet.css\" TITLE=\"Style\">\n");
        sb.append("</HEAD>\n");
        sb.append("<BODY>\n");

        sb.append("<CAPTION CLASS=TableHeader>\n");
        sb.append(" ");
        sb.append("Note: ");
        sb.append("<font color=\"#FF0000\">");
        sb.append("red-marked");
        sb.append("</font>");
        sb.append(" files are found also in other folders");
        sb.append(" </CAPTION>");

        sb.append("<table width=\"90%\">\n");

        sb.append("<CAPTION CLASS=Big>\n");

        sb.append("Content of ");
        sb.append("<font color=\"#000080\">");
        sb.append("all");
        sb.append("</font>");
        sb.append(" directories : ");

        sb.append(" </CAPTION>");

        sb.append(" ");
        sb.append(
            "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
        sb.append(java.io.File.separator);
        sb.append(java.io.File.separator);
        sb.append("_content.html\">");
        sb.append("</A> ");
        sb.append(" </CAPTION>");
        sb.append("<tr class=TableHeader width=\"90%\">\n");
        /*
                sb.append(" ");
                sb.append("Note: ");
                sb.append("<font color=\"#FF0000\">");
                sb.append("red");
                sb.append("</font>");
                sb.append(" color means the file was found in several other folders");
        */
        sb.append("<th width=\"50%\">\n");
        sb.append("File");
        sb.append("</th>\n");

        sb.append("<th width=\"25%\">\n");
        sb.append("Changed");
        sb.append("</th>\n");

        sb.append("<th width=\"15%\">\n");
        sb.append("Size");
        sb.append("</th>\n");

        sb.append("</tr>\n");

        //generating tables contents

        if (alAllFiles.size() != 0) {

            curBG = true;

            for (int b = 0; b < alAllFiles.size(); b++) {

                java.io.File file = (java.io.File) alAllFiles.get(b);

                sb.append("<tr class=TableRow");
                sb.append((curBG) ? "Beige" : "Grey");
                sb.append(">\n");

                sb.append("<td>\n");
// for GO TO icon
                        sb.append("<A  target=\"_blank\" href=\"");
                        sb.append(
                            file.getAbsolutePath() + "\" style=\"color: #FF0000\">\n");
                        sb.append("<img width=\"12\" height=\"12\" border=0 ");
                        sb.append("src=\"");

                        for (int i = 0; i < colFlash + 1; i++) {
                            sb.append("../");
                        }
                        sb.append("images/goto.gif\" ");
                        sb.append("alt=\"go to\">");
                        sb.append("</A>\n");

//

                if (containsFiles.contains(file.getName())) {
                    sb.append("<font color=\"#FF0000\">");

                    sb.append("<A href=\"../");
                    sb.append("dirsForFile");
                    sb.append(java.io.File.separator);
                    sb.append(
                        file.getName()
                            + "_dirsList.html\" TARGET=\"data\" style=\"color: #FF0000\">\n");

                    sb.append(file.getAbsolutePath() + "\n");
                    sb.append("</A><BR>\n");

                } else {
                    sb.append("<font color=\"#004080\">");
                    sb.append(file.getAbsolutePath() + "\n");
                }

                sb.append("</font>");
                sb.append("</td>\n");

                sb.append("<td>\n");

                java.util.Date fileDate = new java.util.Date(file.lastModified());
                String lastModified =
                    java
                        .text
                        .DateFormat
                        .getDateTimeInstance(
                            java.text.DateFormat.SHORT,
                            java.text.DateFormat.SHORT,
                            java.util.Locale.GERMAN)
                        .format(fileDate);

                sb.append(lastModified);
                sb.append("</td>\n");

                sb.append("<td align=\"right\">\n");

                String fileLen = null;
                String origLen = new java.lang.Long(file.length()).toString();

                if (origLen.length() > 3) {
                    fileLen =
                        origLen.substring(0, origLen.length() - 3)
                            + " "
                            + origLen.substring(origLen.length() - 3, origLen.length());
                } else
                    fileLen = origLen;

                sb.append(fileLen);
                sb.append("</td>\n");

                curBG = !curBG;

                sb.append("</tr>\n");

            } // end for
        } // end if
        sb.append("</table>\n");
        sb.append("<br>");
        sb.append("<img width=\"12\" height=\"12\" border=0 ");
        sb.append("src=\"");

        for (int i = 0; i < colFlash + 1; i++) {
            sb.append("../");
        }
        sb.append("images/goto.gif\" ");
        sb.append("alt=\"go to\">");
        sb.append(" - link to open according file ");
        sb.append("<br>");
        sb.append("<br>");
        sb.append(
                "<b> Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine \n</b>");
        sb.append("<br>");
        sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

        sb.append("</BODY>\n");
        sb.append("</HTML>\n");

        out.println(sb.toString());

        out.flush();
        out.close();

    }
        /**
        	* Creates the bottom left frame, which contains the list of the all variables
        	* @param out java.io.PrintWriter object to use for output
        	*/

        public void writeAllVarCatalog(
            java.io.PrintWriter out,
            java.util.TreeMap tmSystemOut) {

            StringBuffer sb = new StringBuffer();
            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>All objects</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");
            sb.append(
                "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"../stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");
            sb.append("<P></P>\n");
            //retrieving schema names

            //listing tables
            sb.append("<A NAME=\"Tables\">");
            sb.append("<P CLASS=IncreasedBold>System variables</P><DIV CLASS=Normal>\n");

            java.util.Iterator itvar = tmSystemOut.keySet().iterator();

            //		alDirList
            String currVar = "";

            //        for (int b=0; b<alDirList.size(); b++){

            while (itvar.hasNext()) {

                //            String currDir = (String) it.next();

                currVar = (String) itvar.next();

                sb.append("<A href=\".");
                sb.append(java.io.File.separator);
                sb.append("\n");
                sb.append(currVar);
                sb.append("_varobjects.html\" TARGET=\"data\">\n");
                sb.append(currVar);
                sb.append("</A><BR>\n");
            }

            sb.append("<BR>\n");

            sb.append("</DIV>\n");
            sb.append("</BODY>\n");
            sb.append("</HTML>\n");
            out.println(sb.toString());
            out.flush();
            out.close();
        }
        /**
         * Creates the stylesheet file
         * @param out java.io.PrintWriter object to use for output
         */
        public void writeCSS(java.io.PrintWriter out) {
            StringBuffer sb = new StringBuffer();
            sb.append(
                "body { background-color: #FFFFF5; font-size: 10pt; font-family: Arial, Verdana; font-weight: normal }\n\n");
            sb.append("\n");
            sb.append(
                ".Normal { font-size: 10pt; font-family: Arial, Verdana; font-weight: normal }\n");
            sb.append(
                ".Bold { font-size: 10pt; font-family: Arial, Verdana; font-weight: bold }\n");
            sb.append(
                ".Increased { font-size: 11pt; font-family: Arial, Verdana; font-weight: normal }\n");
            sb.append(
                ".IncreasedBold { font-size: 11pt; font-family: Arial, Verdana; font-weight: bold }\n");
            sb.append(
                ".Head { font-size: 14pt; font-family: Arial, Verdana; font-weight: bold; text-align: center }\n");
            sb.append(
                ".Big { font-size: 14pt; font-family: Arial, Verdana; font-weight: bold; text-align: left }\n");
            sb.append("\n");
            sb.append(".PrimaryKey { color: red; font-weight: bold }\n");
            sb.append(".ForeignKey { color: blue; font-weight: bold}\n");
            sb.append(".PKSample { background: red; font-weight: bold}\n");
            sb.append(".FKSample { background: blue; font-weight: bold}\n");
            sb.append(
                ".TableHeader { background: blanchedalmond; font-size: 10pt; font-family: Arial, Verdana; font-weight: bold } \n");
            sb.append(
                ".TableRowGrey { background: lightgrey; font-size: 10pt; font-family: Arial, Verdana; font-weight: normal } \n");
            sb.append(
                ".TableRowBeige{ background: beige; font-size: 10pt; font-family: Arial, Verdana; font-weight: normal } \n");
            out.println(sb.toString());
            out.flush();
            out.close();
        }
        /**
        	* Creates the bottom left frame, which contains the list of the directories
        	* @param out java.io.PrintWriter object to use for output
        	*/

        public void writeDirCatalog(java.io.PrintWriter out, String currDirIn) {

            ////
            /*
                    String s1 = "";
                    s1 = s;
                    boolean flag = false;
                    int j = 0;
                    for(int i = s1.indexOf(File.separator); i != -1; i = s1.indexOf(File.separator, i + 1))
                    {
                        j++;
                    }

                    if(!linux && s.length() != 3)
                    {
                        j++;
                    }
            */
            ///////

            String currDirFlash = "";
            //***

            currDirFlash = currDirIn;

            int flash = 0;
            boolean endFlash = true;
            int colFlash = 0;

            endFlash = true;
            flash = currDirFlash.indexOf(java.io.File.separator);

            while (flash != -1) {
                colFlash += 1;
                flash = currDirFlash.indexOf(java.io.File.separator, flash + 1);

            } //end while

            //for drive:\
            if ((!linux) && (currDirIn.length() != 3)) {
                colFlash += 1;
            }
            // ***

            StringBuffer sb = new StringBuffer();
            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>All objects</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\n");
            sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

            for (int i = 0; i < colFlash; i++) {
                sb.append("../");
            }
            sb.append("stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");
            sb.append("<DIV CLASS=IncreasedBold>" + currDirIn + "</DIV>\n");
            sb.append("<P></P>\n");
            sb.append("<P></P>\n");

            //listing tables
            sb.append("<A NAME=\"Tables\">");

            String key = null;
            String currDirLink = null;
            int countDirs = 0;

            java.util.Iterator it = htOut.keySet().iterator();

            String currDir = "";

            while (it.hasNext()) {

                /////////////

                countDirs++;

                currDir = (String) it.next();
                int flashCut = 0;

                if (!linux) {
                    for (int i = 1; i <= colFlash; i++) {

                        flashCut = currDir.indexOf(java.io.File.separator, flashCut + 1);

                    }
                }

                if (!linux) {
                    if (flashCut != -1) {
                        currDirLink = currDir.substring(flashCut + 1, currDir.length());
                    } else {
                        currDirLink = "";
                    }
                } else { //end if linux
                    currDirLink = currDir.substring(currDirIn.length(), currDir.length());
                }

                sb.append("<A href=\".");

                if (!linux) {
                    sb.append(java.io.File.separator);
                    sb.append("\n");
                }
                sb.append(currDirLink);

                if (flashCut != -1) {
                    sb.append(java.io.File.separator);
                }
                sb.append("directories_content.html\" TARGET=\"data\">\n");
                sb.append(currDir);
                sb.append("</A><BR>\n");
            }

            if (countDirs == 0) {
                sb.append("No matched to your parameters are found");
            }

            sb.append("</DIV>\n");
            sb.append("</BODY>\n");
            sb.append("</HTML>\n");
            out.println(sb.toString());
            out.flush();
            out.close();
        }
        /**
        * Produces HTML document with the list of directories for some file
        * @param out java.io.PrintWriter object to use for output
        * @param fileName the name of the file
        * @param alDirsList java.util.ArrayList the names of the directories for some file
        */

        public Object writeDirListForFileContent(
            java.io.PrintWriter out,
            String fileName,
            java.util.ArrayList alDirsList) {

            int j;
            long n = 0;
            boolean curBG;
            StringBuffer sb = new StringBuffer();

            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>\n");

            sb.append(" ");
            sb.append(" content");
            sb.append("</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

            sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

            sb.append("../");

            sb.append("stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");

            sb.append("<table width=\"90%\">\n");
            sb.append("<CAPTION CLASS=Big>\n");

            sb.append(" File ");
            sb.append("<font color=\"#000080\">");
            sb.append(fileName);
            sb.append("</font>");
            sb.append(" is located in following directories:");

            sb.append(" ");
            sb.append(
                "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
            sb.append(fileName);
            sb.append(java.io.File.separator);
            sb.append(java.io.File.separator);
            sb.append("_content.html\">");
            sb.append("</A> ");
            sb.append(" </CAPTION>");
            sb.append("<tr class=TableHeader width=\"90%\">\n");

            sb.append("<th width=\"60%\">\n");
            sb.append("Folder:");
            sb.append("</th>\n");

            sb.append("<th width=\"25%\">\n");
            sb.append("File was changed:");
            sb.append("</th>\n");

            sb.append("<th width=\"15%\">\n");
            sb.append("File size:");
            sb.append("</th>\n");

            sb.append("</tr>\n");

            java.io.File file = (java.io.File) alDirsList.get(0);

            //generating tables contents

            if (alDirsList.size() != 0) {

                curBG = true;

                for (int b = 0; b < alDirsList.size(); b++) {

                    file = (java.io.File) alDirsList.get(b);

                    sb.append("<tr class=TableRow");
                    sb.append((curBG) ? "Beige" : "Grey");
                    sb.append(">\n");

                    sb.append("<td>\n");
// for GO TO icon
//                        sb.append("<A  TARGET=\"data\" href=\"");
                        sb.append("<A  target=\"_blank\" href=\"");
//                        for (int i = 0; i < colFlash + 2; i++) {
//                            sb.append("../");
//                        }
//                        sb.append(notClearLink);
//                        sb.append(java.io.File.separator);
                        sb.append(
                            file.getParent() + "\" style=\"color: #FF0000\">\n");
                        sb.append("<img width=\"12\" height=\"12\" border=0 ");
                        sb.append("src=\"");

                        for (int i = 0; i < colFlash + 1; i++) {
                            sb.append("../");
                        }
                        sb.append("images/goto.gif\" ");
                        sb.append("alt=\"go to\">");
                        sb.append("</A>\n");

//

                    sb.append("<A href=\"../");
                    sb.append("\n");

                    if (!linux) {
                        sb.append(
                            file.getParent().substring(0, 1)
                                + file.getParent().substring(2, file.getParent().length()));
                    } else {
                        sb.append(file.getParent());
                    }

                    sb.append(java.io.File.separator);
                    sb.append("directories_content.html\" TARGET=\"data\">\n");

                    sb.append(file.getParent());
                    sb.append("</A><BR>\n");

                    sb.append("</td>\n");

                    //
                    sb.append("<td>\n");

                    java.util.Date fileDate = new java.util.Date(file.lastModified());
                    String lastModified =
                        java
                            .text
                            .DateFormat
                            .getDateTimeInstance(
                                java.text.DateFormat.SHORT,
                                java.text.DateFormat.SHORT,
                                java.util.Locale.GERMAN)
                            .format(fileDate);

                    sb.append(lastModified);
                    sb.append("</td>\n");

                    sb.append("<td align=\"right\">\n");

                    String fileLen = null;
                    String origLen = new java.lang.Long(file.length()).toString();

                    if (origLen.length() > 3) {
                        fileLen =
                            origLen.substring(0, origLen.length() - 3)
                                + " "
                                + origLen.substring(origLen.length() - 3, origLen.length());
                    } else
                        fileLen = origLen;

                    sb.append(fileLen);
                    sb.append("</td>\n");

                    //
                    curBG = !curBG;

                    sb.append("</tr>\n");

                } // end for
            } // end if
            sb.append("</table>\n");
            sb.append("<br>");
            sb.append("<img width=\"12\" height=\"12\" border=0 ");
            sb.append("src=\"");

            for (int i = 0; i < colFlash + 1; i++) {
                sb.append("../");
            }
            sb.append("images/goto.gif\" ");
            sb.append("alt=\"go to\">");
            sb.append(" - link to open according file ");
            sb.append("<br>");

            sb.append("<br>");
            sb.append(
                "<b> Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine \n</b>");
            sb.append("<br>");
            sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());

            out.flush();
            out.close();

            return file;

        }
        /**
        * Produces HTML document with the list of directories for some file
        * @param out java.io.PrintWriter object to use for output
        * @param fileName the name of the file
        * @param alDirsList java.util.ArrayList the names of the directories for some file
        */

        public Object writeContentListForJar(
            java.io.PrintWriter out,
            String contentName,
            java.util.ArrayList alJarsList,
            java.util.ArrayList containsFiles,
            boolean contentsJar,
            boolean contentsZip) {

            int j;
            long n = 0;
            boolean curBG;
            StringBuffer sb = new StringBuffer();

            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>\n");

            sb.append(" ");
            sb.append(" content");
            sb.append("</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

            sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

            sb.append("../");

            sb.append("stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");

            sb.append("<CAPTION CLASS=TableHeader>\n");
            sb.append(" ");
            sb.append("Note: ");
            sb.append("<font color=\"#FF0000\">");
            sb.append("red-marked");
            sb.append("</font>");
            sb.append(" contents are found also in any files");
            sb.append(" </CAPTION>");

            sb.append("<table width=\"90%\">\n");
            sb.append("<CAPTION CLASS=Big>\n");

            sb.append(" Content ");
            sb.append("<font color=\"#000080\">");
            sb.append(contentName);
            sb.append("</font>");
            sb.append(" is located in following files:");

            sb.append(" ");
            sb.append(
                "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
            sb.append(contentName);
            sb.append(java.io.File.separator);
            sb.append(java.io.File.separator);
            sb.append("_content.html\">");
            sb.append("</A> ");
            sb.append(" </CAPTION>");
            sb.append("<tr class=TableHeader width=\"90%\">\n");

            sb.append("<th width=\"60%\">\n");
            sb.append("File:");
            sb.append("</th>\n");

                sb.append("<th width=\"25%\">\n");
               sb.append("File was changed:");
                sb.append("</th>\n");

                sb.append("<th width=\"15%\">\n");
                sb.append("File size:");
                sb.append("</th>\n");

            sb.append("</tr>\n");

            //java.util.jar.JarFile content = (java.util.jar.JarFile) alJarsList.get(0);
            java.io.File content = (java.io.File) alJarsList.get(0);

            //generating tables contents

            if (alJarsList.size() != 0) {

                curBG = true;

                for (int b = 0; b < alJarsList.size(); b++) {

                    //content = (java.util.jar.JarFile) alJarsList.get(b);
                    content = (java.io.File) alJarsList.get(b);

                    sb.append("<tr class=TableRow");
                    sb.append((curBG) ? "Beige" : "Grey");
                    sb.append(">\n");

                    sb.append("<td>\n");
                    /*
                                sb.append("<A href=\"../");
                                sb.append("\n");

                                if (!linux) {
                    //                sb.append(
                    //                    content.getParent().substring(0, 1)
                    //                        + content.getParent().substring(2, content.getParent().length()));
                                    sb.append(
                                        content.getName().substring(0, 1)
                                            + content.getName().substring(2, content.getName().length()));

                                } else {
                                    //                    sb.append(content.getParent());
                                }

                                sb.append(java.io.File.separator);
                                sb.append("jars_content.html\" TARGET=\"data\">\n");

                                sb.append(content.getName());
                                sb.append("</A><BR>\n");
                    */
                    ////
// for GO TO icon
//                        sb.append("<A  TARGET=\"data\" href=\"");
                        sb.append("<A  target=\"_blank\" href=\"");
//                        for (int i = 0; i < colFlash + 2; i++) {
//                            sb.append("../");
//                        }
                        sb.append(
                            content.getAbsolutePath() + "\" style=\"color: #FF0000\">\n");

                        sb.append("<img width=\"12\" height=\"12\" border=0 ");
                        sb.append("src=\"");

                        for (int i = 0; i < colFlash + 1; i++) {
                            sb.append("../");
                        }
                        sb.append("images/goto.gif\" ");
                        sb.append("alt=\"go to\">");
                        sb.append("</A>\n");


//

                    String clearName = content.getName();
                    int t = clearName.lastIndexOf(java.io.File.separator);
                    clearName = clearName.substring(t + 1, clearName.length());
                    //                if (containsFiles.contains(content.getName())) {
                    if (containsFiles.contains(clearName)) {
                        sb.append("<font color=\"#FF0000\">");

                        sb.append("<A href=\".");
                        for (int i = 0; i < colFlash + 3; i++) {
                            sb.append("../");
                        }

                        //			sb.append(java.io.File.separator);
                        sb.append("dirsForFile");
                        sb.append(java.io.File.separator);

                        sb.append(
                            clearName + "_dirsList.html\" TARGET=\"data\" style=\"color: #FF0000\">\n");
                        sb.append(content.getAbsolutePath() + "\n");
                        sb.append("</A>\n");

                    } else {
                        sb.append("<font color=\"#004080\">");
                        sb.append(content.getName() + "\n");
                    }
                    /////

                    String currDir = content.getAbsolutePath();
                    String currPath = null;
                    if (!linux) {
                        currPath =
                            currDir.substring(0, 1)
                                + java.io.File.separator
                                + currDir.substring(3, currDir.length());
                    } else {
                        currPath = currDir;
                    }

                    ////
                    sb.append("<font color=\"#FF0000\">");

///
///
////
                        sb.append("<A  TARGET=\"data\" href=\".");
                        for (int i = 0; i < colFlash + 3; i++) {
                            sb.append("../");
                        }
                        sb.append(currPath);
                        sb.append(
                            "_content.html\" style=\"color: #FF0000\">\n");
                            sb.append("<img width=\"12\" height=\"12\" border=0 ");
                            sb.append("src=\"");
                        for (int i = 0; i < colFlash + 1; i++) {
                            sb.append("../");
                        }
                        sb.append("images/contents.gif\" ");
                        sb.append("alt=\"contents\">");
                        sb.append("</A>\n");
////
//
/*
                    sb.append("<A href=\".");
                    for (int i = 0; i < colFlash + 3; i++) {
                        sb.append("../");
                    }
                    sb.append(
                        currPath + "_content.html\" TARGET=\"data\" style=\"color: #FF0000\">\n");

                    sb.append("<font color=\"#000080\">");
                    sb.append(" contents" + "\n");
                    sb.append("</font>");
                    sb.append("</A>\n");
*/
                    sb.append("</font>");
                    ////
                    sb.append("</td>\n");


                        sb.append("<td>\n");

                                    java.util.Date contentDate = new java.util.Date(content.lastModified());
                                String lastModified =
                                    java
                                        .text
                                        .DateFormat
                                        .getDateTimeInstance(
                                            java.text.DateFormat.SHORT,
                                            java.text.DateFormat.SHORT,
                                            java.util.Locale.GERMAN)
                                        .format(contentDate);

                                sb.append(lastModified);

                                sb.append("</td>\n");

                                sb.append("<td align=\"right\">\n");

                                String contentLen = null;
                                String origLen = new java.lang.Long(content.length()).toString();


                                if (origLen.length() > 3) {
                                    contentLen =
                                        origLen.substring(0, origLen.length() - 3)
                                            + " "
                                            + origLen.substring(origLen.length() - 3, origLen.length());
                                } else
                                    contentLen = origLen;

                                sb.append(contentLen);

                    //            sb.append("</td>\n");

                    //
                    curBG = !curBG;

                    sb.append("</tr>\n");

                } // end for
            } // end if
            sb.append("</table>\n");
            sb.append("<br>");
            sb.append("<img width=\"12\" height=\"12\" border=0 ");
            sb.append("src=\"");

            for (int i = 0; i < colFlash + 1; i++) {
                sb.append("../");
            }
            sb.append("images/goto.gif\" ");
            sb.append("alt=\"go to\">");
            sb.append(" - link to open according file ");


            sb.append("<br>");
                sb.append("<img width=\"12\" height=\"12\" border=0 ");
                sb.append("src=\"");
            for (int i = 0; i < colFlash + 1; i++) {
                sb.append("../");
            }
            sb.append("images/contents.gif\" ");
            sb.append("alt=\"contents\">");
            sb.append(" - link to contents (files and packages) for archive file");

            sb.append("<br>");

        sb.append("<br>");
        sb.append(
                "<b> Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine \n</b>");
        sb.append("<br>");
        sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());

            out.flush();
            out.close();

            return content;

        }

        /**
        * Produces HTML document with the list of directories for some file
        * @param out java.io.PrintWriter object to use for output
        * @param fileName the name of the file
        * @param alDirsList java.util.ArrayList the names of the directories for some file
        */

        public Object writeListForJar(
            java.io.PrintWriter out,
            String fileName,
            java.util.ArrayList alDirsList) {

            int j;
            long n = 0;
            boolean curBG;
            StringBuffer sb = new StringBuffer();

            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>\n");

            sb.append(" ");
            sb.append(" content");
            sb.append("</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

            sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

            sb.append("../");

            sb.append("stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");

            sb.append("<table width=\"90%\">\n");
            sb.append("<CAPTION CLASS=Big>\n");

            sb.append(" File ");
            sb.append("<font color=\"#000080\">");
            sb.append(fileName);
            sb.append("</font>");
            sb.append(" is located in following directories:");

            sb.append(" ");
            sb.append(
                "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
            sb.append(fileName);
            sb.append(java.io.File.separator);
            sb.append(java.io.File.separator);
            sb.append("_content.html\">");
            sb.append("</A> ");
            sb.append(" </CAPTION>");
            sb.append("<tr class=TableHeader width=\"90%\">\n");

            sb.append("<th width=\"60%\">\n");
            sb.append("Folder:");
            sb.append("</th>\n");

            sb.append("<th width=\"25%\">\n");
            sb.append("File was changed:");
            sb.append("</th>\n");

            sb.append("<th width=\"15%\">\n");
            sb.append("File size:");
            sb.append("</th>\n");

            sb.append("</tr>\n");

            java.io.File file = (java.io.File) alDirsList.get(0);

            //generating tables contents

            if (alDirsList.size() != 0) {

                curBG = true;

                for (int b = 0; b < alDirsList.size(); b++) {

                    file = (java.io.File) alDirsList.get(b);

                    sb.append("<tr class=TableRow");
                    sb.append((curBG) ? "Beige" : "Grey");
                    sb.append(">\n");

                    sb.append("<td>\n");

                    sb.append("<A href=\"../");
                    sb.append("\n");

                    if (!linux) {
                        sb.append(
                            file.getParent().substring(0, 1)
                                + file.getParent().substring(2, file.getParent().length()));
                    } else {
                        sb.append(file.getParent());
                    }

                    sb.append(java.io.File.separator);
                    sb.append("directories_content.html\" TARGET=\"data\">\n");

                    sb.append(file.getParent());
                    sb.append("</A><BR>\n");

                    sb.append("</td>\n");

                    //
                    sb.append("<td>\n");

                    java.util.Date fileDate = new java.util.Date(file.lastModified());
                    String lastModified =
                        java
                            .text
                            .DateFormat
                            .getDateTimeInstance(
                                java.text.DateFormat.SHORT,
                                java.text.DateFormat.SHORT,
                                java.util.Locale.GERMAN)
                            .format(fileDate);

                    sb.append(lastModified);
                    sb.append("</td>\n");

                    sb.append("<td align=\"right\">\n");

                    String fileLen = null;
                    String origLen = new java.lang.Long(file.length()).toString();

                    if (origLen.length() > 3) {
                        fileLen =
                            origLen.substring(0, origLen.length() - 3)
                                + " "
                                + origLen.substring(origLen.length() - 3, origLen.length());
                    } else
                        fileLen = origLen;

                    sb.append(fileLen);
                    sb.append("</td>\n");

                    //
                    curBG = !curBG;

                    sb.append("</tr>\n");

                } // end for
            } // end if
            sb.append("</table>\n");
            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());

            out.flush();
            out.close();

            return file;

        }

        /**
        	* Creates the main frame structure
        	* @param out java.io.PrintWriter object to use for output
        	*/
        public void writeFrameset(java.io.PrintWriter out) {
            StringBuffer sb = new StringBuffer();
            sb.append("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\n");
            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>Helicon System Analyzer</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n");
            sb.append(
                "<META NAME=\"description\" CONTENT=\"System Analyzer main frameset\">\n");
            sb.append("<META NAME=\"author\" CONTENT=\"Vladimir Koval\">\n");
            sb.append("<META NAME=\"author\" CONTENT=\"(c) 2002 Helicon, Ukraine\">\n");
            sb.append("<META NAME=\"robots\" CONTENT=\"all\">\n");
            sb.append("<META NAME=\"language\" CONTENT=\"English\">\n");
            sb.append("</HEAD>\n");
            sb.append("<FRAMESET cols=40%,60%>\n");
            sb.append("<FRAMESET rows=40%,60%>\n");
            sb.append("<FRAME src=\"main.html\" name=\"main\">\n");
            sb.append("<FRAME src=\"allobjects.html\" name=\"catalog\">\n");
            sb.append("</FRAMESET>\n");
            sb.append("<FRAME src=\"right.html\" name=\"data\">\n");
            sb.append("</FRAMESET>\n");
            sb.append("<NOFRAMES>\n");
            sb.append("<H2>Frame Alert</H2>\n");
            sb.append(
                "<P>This document is designed to be viewed using the frames feature. If you see this message, you are using a non-frame-capable web client.\n");
            sb.append("</NOFRAMES>\n");
            sb.append("</HTML>\n");
            out.println(sb.toString());
            out.flush();
            out.close();
        }
        /**
        	* Creates the top left frame, which contains the links for
        	* system variables and the links for all directories
        	* @param out java.io.PrintWriter object to use for output
        	* @param host host name, used for direct HTML output purposes only
        	*/
        public void writeMain(
            java.io.PrintWriter out,
            String host,
            String database,
            String connFactory,
            java.util.ArrayList alDirList,
            java.util.TreeMap tmSystemOut) {

            StringBuffer sb = new StringBuffer();
            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>Folder structure</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=windows-1252\">\n");
            sb.append(
                "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");
            sb.append("<DIV CLASS=Head>Helicon System Analyzer (c) 2002 v.0.95 </DIV>\n");

            sb.append("<BR>\n");

            sb.append("<A href=\".");
            sb.append(java.io.File.separator);
            sb.append("\n");
            sb.append("variables");
            sb.append(java.io.File.separator);
            sb.append("all_varobjects.html\" TARGET=\"catalog\">\n");
//            sb.append("<DIV CLASS=IncreasedBold>System variables</DIV>\n");
            sb.append("System variables\n");
            sb.append("</A>\n");

            sb.append("<BR>\n");
            sb.append("<A href=\".");
            sb.append(java.io.File.separator);
            sb.append("\n");
            sb.append("AllFiles");
            sb.append(java.io.File.separator);
            sb.append("allFiles_content.html\" TARGET=\"data\">\n");
//            sb.append("<DIV CLASS=IncreasedBold>All Files</DIV>\n");
            sb.append("All Files\n");
            sb.append("</A>\n");
            sb.append("<BR>\n");

//            sb.append("<BR>\n");
            sb.append("<A href=\".");
            sb.append(java.io.File.separator);
            sb.append("\n");
            sb.append("AllJars");
            sb.append(java.io.File.separator);
            sb.append("allJars_content.html\" TARGET=\"data\">\n");
//            sb.append("<DIV CLASS=IncreasedBold>All archive files</DIV>\n");
            sb.append("All archive files\n");
            sb.append("</A>\n");
            sb.append("<BR>");
            sb.append("<BR>");
            sb.append("<DIV CLASS=IncreasedBold>Folders :</DIV>\n");


            java.util.Iterator it = htOut.keySet().iterator();

            //		alDirList

            String currDir = "";
            String currDirLink = null;
            String currDirWithoutFlash = null;

            for (int b = 0; b < alDirList.size(); b++) {

                currDir = (String) alDirList.get(b);

                if (!linux) {
                    if ((currDir.length() != 3) && (currDir.indexOf(":", 1) != -1)) {
                        currDirLink =
                            currDir.substring(0, 1)
                                + java.io.File.separator
                                + currDir.substring(3, currDir.length());
                    } else
                        if (currDir.indexOf(":", 1) != -1) {
                            currDirLink = currDir.substring(0, 1);
                        }
                } else { //end if
                    currDirLink = currDir;
                } //end else

                sb.append("<A href=\".");
                sb.append(java.io.File.separator);
                sb.append("\n");
                sb.append(currDirLink);

                sb.append(java.io.File.separator);

                sb.append("dirobjects.html\" TARGET=\"catalog\">\n");
                sb.append(currDir);
                sb.append("</A><BR>\n");
            }

            sb.append("</BODY>\n");
            sb.append("</HTML>\n");
            out.println(sb.toString());
            out.flush();
            out.close();
        }
        /**
        	* Produces HTML document with the files of the specified directory
        	* @param out java.io.PrintWriter object to use for output
        	* @param clearLink String the clear link to the file
        	* @param alFiles java.util.ArrayList the list of files  of the specified folder
            * @param containsFiles java.util.ArrayList the list of dublicate files
        	* @param currDirIn String the name of current folder
        	*/

        public Object writeObjectContent(
            java.io.PrintWriter out,
            String clearLink,
            java.util.ArrayList alFiles,
            java.util.ArrayList containsFiles,
            String currDirIn,
            boolean contentsJar,
            boolean contentsZip) {

            int j;
            long n = 0;
            boolean curBG;
            StringBuffer sb = new StringBuffer();

            String currDirFlash = null;
            //***
            currDirFlash = currDirIn;

            int flash = 0;
            boolean endFlash = true;
            int colFlash = 0;

            endFlash = true;
            flash = currDirFlash.indexOf(java.io.File.separator);


            // for NOT clear link
            String notClearLink = null;

             if (!linux) {
                 notClearLink =
                     clearLink.substring(0, 1)
                         + ":"
                         + java.io.File.separator
                         + clearLink.substring(2, clearLink.length());
             } else {
                 notClearLink = clearLink;
             }

            while (flash != -1) {
                colFlash += 1;
                flash = currDirFlash.indexOf(java.io.File.separator, flash + 1);

            } //end while

            //for drive:\
            if (!linux) {
                colFlash += 1;
            }
            // ***

            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>\n");
            sb.append(" ");
            sb.append(" content");
            sb.append("</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

            sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

            for (int i = 0; i < colFlash; i++) {
                sb.append("../");
            }
            sb.append("stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");

            sb.append("<CAPTION CLASS=TableHeader>\n");
            sb.append(" ");
            sb.append("Note: ");
            sb.append("<font color=\"#FF0000\">");
            sb.append("red-marked");
            sb.append("</font>");
            sb.append(" files are found also in any folders");
            sb.append(" </CAPTION>");

            sb.append("<table width=\"90%\">\n");
            sb.append("<CAPTION CLASS=Big>\n");

            sb.append("Content of ");
            sb.append("<font color=\"#000080\">");
            sb.append(clearLink.substring(0, 1));
            sb.append(":");
            sb.append(clearLink.substring(1, clearLink.length()));
            sb.append("</font>");
            sb.append(" folder : ");

            sb.append(" ");
            sb.append(
                "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
            sb.append(clearLink);
            sb.append(java.io.File.separator);
            sb.append(java.io.File.separator);
            sb.append("_content.html\">");
            sb.append("</A> ");
            sb.append(" </CAPTION>");

            sb.append("<tr class=TableHeader width=\"90%\">\n");

            sb.append("<th width=\"60%\">\n");
            sb.append("File");
            sb.append("</th>\n");

            sb.append("<th width=\"25%\">\n");
            sb.append("Changed");
            sb.append("</th>\n");

            sb.append("<th width=\"15%\">\n");
            sb.append("Size");
            sb.append("</th>\n");

            sb.append("</tr>\n");
            java.io.File file = null;
            String ext = null;
            //generating tables contents
            if (alFiles.size() != 0) {

                file = (java.io.File) alFiles.get(0);

                curBG = true;

                for (int b = 0; b < alFiles.size(); b++) {

                    file = (java.io.File) alFiles.get(b);

                    //			for (curBG = true; rs.next(); curBG = !curBG) {

                    sb.append("<tr class=TableRow");
                    sb.append((curBG) ? "Beige" : "Grey");
                    sb.append(">\n");

                    sb.append("<td>\n");

// for GO TO icon
//                        sb.append("<A  TARGET=\"data\" href=\"");
                        sb.append("<A  target=\"_blank\" href=\"");
//                        for (int i = 0; i < colFlash + 2; i++) {
//                            sb.append("../");
//                        }
                        sb.append(notClearLink);
                        sb.append(java.io.File.separator);
                        sb.append(
                            file.getName() + "\" style=\"color: #FF0000\">\n");
                        sb.append("<img width=\"12\" height=\"12\" border=0 ");
                        sb.append("src=\".");

                        for (int i = 0; i < colFlash + 2; i++) {
                            sb.append("../");
                        }
                        sb.append("images/goto.gif\" ");
                        sb.append("alt=\"go to\">");
                        sb.append("</A>\n");

//

                    if (containsFiles.contains(file.getName())) {
                        sb.append("<font color=\"#FF0000\">");

                        sb.append("<A href=\".");
                        for (int i = 0; i < colFlash + 2; i++) {
                            sb.append("../");
                        }

                        //			sb.append(java.io.File.separator);
                        sb.append("dirsForFile");
                        sb.append(java.io.File.separator);

                        sb.append(
                            file.getName()
                                + "_dirsList.html\" TARGET=\"data\" style=\"color: #FF0000\">\n");
                        sb.append(file.getName() + "\n");
                        sb.append("</A>\n");

                    } else {
                        sb.append("<font color=\"#004080\">");
                        sb.append(file.getName() + "\n");
                    }

                    //additional link to JAR list
                    //difinition of extension
                    int point = file.getName().lastIndexOf(".");
                    ext = file.getName().substring(point + 1, file.getName().length());

                    //                if (ext.equals("jar") || (ext.equals("zip"))) {
                    if ((ext.equals("jar") && contentsJar) || (ext.equals("zip") && contentsZip)) {

                        sb.append("<font color=\"#FF0000\">");
//<a target='bottom' href='file.x'><img width='16' height='16' border=0 src='reply.gif' alt='contents'></a>
////
                        sb.append("<A  TARGET=\"data\" href=\".");
                        for (int i = 0; i < colFlash + 2; i++) {
                            sb.append("../");
                        }
                        sb.append(clearLink);
                        sb.append(java.io.File.separator);
                        sb.append(
                            file.getName() + "_content.html\" style=\"color: #FF0000\">\n");
                            sb.append("<img width=\"12\" height=\"12\" border=0 ");
                            sb.append("src=\".");
                        for (int i = 0; i < colFlash + 2; i++) {
                            sb.append("../");
                        }
                        sb.append("images/contents.gif\" ");
                        sb.append("alt=\"contents\">");
                        sb.append("</A>\n");
////
                    }

                    sb.append("</font>");
                    sb.append("</td>\n");

                    sb.append("<td>\n");

                    java.util.Date fileDate = new java.util.Date(file.lastModified());
                    String lastModified =
                        java
                            .text
                            .DateFormat
                            .getDateTimeInstance(
                                java.text.DateFormat.SHORT,
                                java.text.DateFormat.SHORT,
                                java.util.Locale.GERMAN)
                            .format(fileDate);

                    sb.append(lastModified);
                    sb.append("</td>\n");

                    sb.append("<td align=\"right\">\n");

                    String fileLen = null;
                    String origLen = new java.lang.Long(file.length()).toString();

                    if (origLen.length() > 3) {
                        fileLen =
                            origLen.substring(0, origLen.length() - 3)
                                + " "
                                + origLen.substring(origLen.length() - 3, origLen.length());
                    } else
                        fileLen = origLen;

                    sb.append(fileLen);
                    sb.append("</td>\n");

                    curBG = !curBG;

                    sb.append("</tr>\n");

                } // end for
            } // end if
            sb.append("</table>\n");
            sb.append("<br>");
            sb.append("<img width=\"12\" height=\"12\" border=0 ");
            sb.append("src=\".");

            for (int i = 0; i < colFlash + 2; i++) {
                sb.append("../");
            }
            sb.append("images/goto.gif\" ");
            sb.append("alt=\"go to\">");
            sb.append(" - link to open according file ");

            if ((ext.equals("jar") && contentsJar) || (ext.equals("zip") && contentsZip)) {
              sb.append("<br>");
              sb.append("<img width=\"12\" height=\"12\" border=0 ");
              sb.append("src=\".");
              for (int i = 0; i < colFlash + 2; i++) {
                   sb.append("../");
              }
              sb.append("images/contents.gif\" ");
              sb.append("alt=\"contents\">");
              sb.append(" - link to contents (files and packages) for archive file");
            }
            sb.append("<br>");
            sb.append("<br>");
            sb.append(
                "<b> Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine \n</b>");
            sb.append("<br>");
            sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());

            out.flush();
            out.close();

            return file;

        }
        /**
        	* Creates the right frame
        	* @param out java.io.PrintWriter object to use for output
        	*/
        public void writeRightFrame(java.io.PrintWriter out) {
            StringBuffer sb = new StringBuffer();
            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>Helicon System Analyzer</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");
            sb.append(
                "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");
            sb.append(
                "<DIV CLASS=Head>Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine </DIV>\n");
            sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

            sb.append(
                "<br>Java projects outsourcing and outtasking: best performance-to-price ratio");
            sb.append("<HR><P CLASS=Bold>\n");

            java.util.Date myDate = new java.util.Date();
            String currentData =
                java
                    .text
                    .DateFormat
                    .getDateTimeInstance(
                        java.text.DateFormat.LONG,
                        java.text.DateFormat.SHORT,
                        java.util.Locale.ENGLISH)
                    .format(myDate);

            sb.append("Creation date : " + currentData);

            sb.append("</P><P CLASS=Normal>\n");

            sb.append(
                "This document contains data on the System Information and structure of directories</P><P>\n");
            sb.append("</P>\n");
            sb.append("</BODY>\n");
            sb.append("</HTML>\n");
            out.println(sb.toString());
            out.flush();
            out.close();
        }
        /**
        	* Produces HTML document with the content of the system variables
        	* @param out java.io.PrintWriter object to use for output
        	* @param var String the name of the system variable
        	* @param value String the value of the system variable
        	*/

        public void writeSystemInfoContent(
            java.io.PrintWriter out,
            String var,
            String value) {

            int j;
            long n = 0;
            boolean curBG = true;
            StringBuffer sb = new StringBuffer();

            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>\n");
            sb.append(" ");
            sb.append(" content");
            sb.append("</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

            sb.append(
                "<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"../stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");

            sb.append("<table width=\"80%\">\n");
            sb.append("<CAPTION CLASS=Big>\n");

            sb.append("Value of ");
            sb.append("<font color=\"#000080\">");
            sb.append(var);
            sb.append("</font>");
            sb.append(" variable : ");
            sb.append(" ");
            sb.append(
                "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
            sb.append(var);
            sb.append(java.io.File.separator);
            sb.append(java.io.File.separator);
            sb.append("_content.html\">");
            sb.append("</A> ");
            sb.append(" </CAPTION>");
            sb.append("<tr class=TableHeader>\n");

            sb.append("<th>\n");
            sb.append("Value");
            sb.append("</th>\n");

            sb.append("</tr>\n");

            //generating tables contents

            int currSem = 0;
            int nextSem = 0;

            String newValue = null;
            String shortValue = null;
            java.lang.StringBuffer sbDiv = new java.lang.StringBuffer();
            currSem = value.indexOf(";", 0);

            if (currSem != -1) {
                sbDiv.append(value.substring(0, currSem + 1));
                sbDiv.append("<br>");
            } else {
                shortValue = value;
            }

            while (currSem != -1) {

                nextSem = value.indexOf(";", currSem + 1);

                if (nextSem != -1) {
                    shortValue = value.substring(currSem + 1, nextSem + 1);

                } else {
                    shortValue = value.substring(currSem + 1, value.length());
                }

                sb.append("<tr class=TableRow");
                sb.append((curBG) ? "Beige" : "Grey");
                sb.append(">\n");
                sb.append("<td>\n");

                currSem = nextSem;

                curBG = !curBG;

                sb.append(shortValue);

                sb.append("</td>\n");

                sb.append("</tr>\n");

            }
            if (currSem == -1) {
                sb.append("<tr class=TableRow");
                sb.append((curBG) ? "Beige" : "Grey");
                sb.append(">\n");
                sb.append("<td>\n");
                sb.append(shortValue);
                sb.append("</td>\n");
                sb.append("</tr>\n");

            }

            sb.append("</table>\n");
            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());
            out.flush();
            out.close();

        }

        /**
        * Creates a new instance of the HTMLProducerConsole class
        * @param htOut java.util.TreeMap with files for inputed directory
        */
        public HTMLProducerConsole(java.util.TreeMap htOut, boolean linux) {
            this.htOut = htOut;
            this.linux = linux;
        }

        /**
        * Creates a new instance of the HTMLProducerConsole class
        */
        public HTMLProducerConsole(boolean linux) {
            this.linux = linux;
        }

        /**
        	* Produces HTML document with the files of the specified directory
        	* @param out java.io.PrintWriter object to use for output
        	* @param clearLink String the clear link to the file
        	* @param alFiles java.util.ArrayList the list of files  of the specified folder
            * @param containsFiles java.util.ArrayList the list of dublicate files
        	* @param currDirIn String the name of current folder
        	*/

        public Object writeJarContent(
            java.io.PrintWriter out,
            String clearLink,
            java.util.ArrayList alJarFiles,
            java.util.ArrayList containsContentsJar,
            java.io.File file,
            String currDirIn) {

            int j;
            long n = 0;
            boolean curBG;
            StringBuffer sb = new StringBuffer();

            String currDirFlash = null;
            //***
            currDirFlash = currDirIn;

            int flash = 0;
            boolean endFlash = true;
            int colFlash = 0;

            endFlash = true;
            flash = currDirFlash.indexOf(java.io.File.separator);

            while (flash != -1) {
                colFlash += 1;
                flash = currDirFlash.indexOf(java.io.File.separator, flash + 1);

            } //end while

            //for drive:\
            if (!linux) {
                colFlash += 1;
            }
            // ***

            sb.append("<HTML>\n");
            sb.append("<HEAD>\n");
            sb.append("<TITLE>\n");
            sb.append(" ");
            sb.append(" content");
            sb.append("</TITLE>\n");
            sb.append(
                "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

            sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

            for (int i = 0; i < colFlash; i++) {
                sb.append("../");
            }
            sb.append("stylesheet.css\" TITLE=\"Style\">\n");
            sb.append("</HEAD>\n");
            sb.append("<BODY>\n");

            sb.append("<CAPTION CLASS=TableHeader>\n");
            sb.append(" ");
            sb.append("Note: ");
            sb.append("<font color=\"#FF0000\">");
            sb.append("red-marked");
            sb.append("</font>");
            sb.append(" files are found also in any folders");
            sb.append(" </CAPTION>");

            sb.append("<table width=\"90%\">\n");
            sb.append("<CAPTION CLASS=Big>\n");

            sb.append("Content of ");
            sb.append("<font color=\"#000080\">");
            sb.append(clearLink.substring(0, 1));
            sb.append(":");
            sb.append(clearLink.substring(1, clearLink.length()));
            sb.append("\\" + file.getName() + "");
            sb.append("</font>");
            sb.append(" file : ");

            sb.append(" ");
            sb.append(
                "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
            sb.append(clearLink);
            sb.append(java.io.File.separator);
            sb.append(java.io.File.separator);
            sb.append("_content.html\">");
            sb.append("</A> ");
            sb.append(" </CAPTION>");

            sb.append("<tr class=TableHeader width=\"90%\">\n");

            sb.append("<th width=\"60%\">\n");
            sb.append("File");
            sb.append("</th>\n");

            sb.append("<th width=\"25%\">\n");
            sb.append("Changed");
            sb.append("</th>\n");

            sb.append("<th width=\"15%\">\n");
            sb.append("Size");
            sb.append("</th>\n");

            sb.append("</tr>\n");
            //        java.io.File file = null;
            //generating tables contents
            if (alJarFiles.size() != 0) {
                Object timeObj = (java.lang.Object) alJarFiles.get(0);

                //      	      String fileName = alJarFiles.get(0).toString();

                //			  java.io.File timeFileNew = null;

                //			  timeFileNew =  (java.io.File) timeObj;
                //= new timeObj;
                //            file = (java.io.File) alJarFiles.get(0);

                curBG = true;

                for (int b = 0; b < alJarFiles.size(); b++) {

                    java.util.jar.JarEntry jarEntryFile =
                        (java.util.jar.JarEntry) alJarFiles.get(b);

                    if (!jarEntryFile.isDirectory()) {

                        String contentName = jarEntryFile.getName();
                        String contentNameLink = contentName.replace('/', '_');

                        //			for (curBG = true; rs.next(); curBG = !curBG) {

                        sb.append("<tr class=TableRow");
                        sb.append((curBG) ? "Beige" : "Grey");
                        sb.append(">\n");

                        sb.append("<td>\n");

                        if (containsContentsJar.contains(jarEntryFile.getName())) {
                            sb.append("<font color=\"#FF0000\">");

                            sb.append("<A href=\".");
                            for (int i = 0; i < colFlash + 2; i++) {
                                sb.append("../");
                            }

                            //			sb.append(java.io.File.separator);
                            sb.append("jarsForContent");
                            sb.append(java.io.File.separator);

                            sb.append(
                                contentNameLink
                                    + "_jarsList.html\" TARGET=\"data\" style=\"color: #FF0000\">\n");
                            sb.append(jarEntryFile.getName() + "\n");
                            sb.append("</A><BR>\n");

                        } else {
                            sb.append("<font color=\"#004080\">");
                            sb.append(jarEntryFile.getName() + "\n");
                        }

                        //                sb.append("<font color=\"#004080\">");
                        //                sb.append(jarEntryFile.getName() + "\n");

                        sb.append("</font>");
                        sb.append("</td>\n");

                        sb.append("<td>\n");

                        java.util.Date fileDate = new java.util.Date(jarEntryFile.getTime());
                        String lastModified =
                            java
                                .text
                                .DateFormat
                                .getDateTimeInstance(
                                    java.text.DateFormat.SHORT,
                                    java.text.DateFormat.SHORT,
                                    java.util.Locale.GERMAN)
                                .format(fileDate);

                        sb.append(lastModified);
                        sb.append("</td>\n");

                        sb.append("<td align=\"right\">\n");

                        String fileLen = null;
                        //                String origLen = new java.lang.Long(file.length()).toString();
                        String origLen = new java.lang.Long(jarEntryFile.getSize()).toString();

                        if (origLen.length() > 3) {
                            fileLen =
                                origLen.substring(0, origLen.length() - 3)
                                    + " "
                                    + origLen.substring(origLen.length() - 3, origLen.length());
                        } else
                            fileLen = origLen;

                        sb.append(fileLen);
                        sb.append("</td>\n");

                        curBG = !curBG;

                        sb.append("</tr>\n");

                    } //end if

                } // end for
            } // end if
            sb.append("</table>\n");
            sb.append("<br>");
            sb.append(
                "<b> Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine \n</b>");
            sb.append("<br>");
            sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());

            out.flush();
            out.close();

            return file;

        }

    /**
    	* Produces HTML document with the content of all jars for
    	* the all specified directories
    	* @param out java.io.PrintWriter object to use for output
    	* @param containsFiles java.util.ArrayList the list of all Dublicated names of the all files contained in the all directories
    	* @param alAllFiles java.util.ArrayList the list of all names of the all files contained in the all directories
    	*/

    public void writeAllJarsContent(
        java.io.PrintWriter out,
        java.util.ArrayList containsFiles,
        java.util.ArrayList alListAllJars,
        java.util.ArrayList alAllFiles
    ) {

        int j;
        long n = 0;
        boolean curBG;
        StringBuffer sb = new StringBuffer();

        sb.append("<HTML>\n");
        sb.append("<HEAD>\n");
        sb.append("<TITLE>\n");
        sb.append(" ");
        sb.append(" content");
        sb.append("</TITLE>\n");
        sb.append(
            "<META http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n");

        sb.append("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"");

        sb.append("../");

        sb.append("stylesheet.css\" TITLE=\"Style\">\n");
        sb.append("</HEAD>\n");
        sb.append("<BODY>\n");

        if (alAllFiles.size() != 0){

        sb.append("<CAPTION CLASS=TableHeader>\n");
        sb.append(" ");
        sb.append("Note: ");
        sb.append("<font color=\"#FF0000\">");
        sb.append("red-marked");
        sb.append("</font>");
        sb.append(" files are found also in other folders");
        sb.append(" </CAPTION>");

        sb.append("<table width=\"90%\">\n");

        sb.append("<CAPTION CLASS=Big>\n");

        sb.append("Content of ");
        sb.append("<font color=\"#000080\">");
        sb.append("all");
        sb.append("</font>");
        sb.append(" directories : ");

        sb.append(" </CAPTION>");

        sb.append(" ");
        sb.append(
            "<A HREF=\".." + java.io.File.separator + ".." + java.io.File.separator);
        sb.append(java.io.File.separator);
        sb.append(java.io.File.separator);
        sb.append("_content.html\">");
        sb.append("</A> ");
        sb.append(" </CAPTION>");
        sb.append("<tr class=TableHeader width=\"90%\">\n");
        /*
                sb.append(" ");
                sb.append("Note: ");
                sb.append("<font color=\"#FF0000\">");
                sb.append("red");
                sb.append("</font>");
                sb.append(" color means the file was found in several other folders");
        */
        sb.append("<th width=\"50%\">\n");
        sb.append("File");
        sb.append("</th>\n");

        sb.append("<th width=\"25%\">\n");
        sb.append("Changed");
        sb.append("</th>\n");

        sb.append("<th width=\"15%\">\n");
        sb.append("Size");
        sb.append("</th>\n");

        sb.append("</tr>\n");

            if (alAllFiles.size() != 0) {

                curBG = true;

                for (int b = 0; b < alAllFiles.size(); b++) {

                    java.io.File file = (java.io.File) alAllFiles.get(b);

                    int point = file.getName().lastIndexOf(".");
                    String ext = file.getName().substring(point + 1, file.getName().length());

                    if (ext.equals("jar")||ext.equals("zip") ) {


                    sb.append("<tr class=TableRow");
                    sb.append((curBG) ? "Beige" : "Grey");
                    sb.append(">\n");
                    sb.append("<td>\n");
// for GO TO icon
//                        sb.append("<A  TARGET=\"data\" href=\"");
                        sb.append("<A  target=\"_blank\" href=\"");
                        sb.append(
                           file.getAbsolutePath()  + "\" style=\"color: #FF0000\">\n");
                        sb.append("<img width=\"12\" height=\"12\" border=0 ");
                        sb.append("src=\"");

                        for (int i = 0; i < colFlash + 1; i++) {
                            sb.append("../");
                        }
                        sb.append("images/goto.gif\" ");
                        sb.append("alt=\"go to\">");
                        sb.append("</A>\n");

//

                    if (containsFiles.contains(file.getName())) {
                        sb.append("<font color=\"#FF0000\">");

                        sb.append("<A href=\"../");
                        sb.append("dirsForFile");
                        sb.append(java.io.File.separator);
                        sb.append(
                            file.getName()
                                + "_dirsList.html\" TARGET=\"data\" style=\"color: #FF0000\">\n");

                        sb.append(file.getAbsolutePath() + "\n");
                        sb.append("</A><BR>\n");

                    } else {
                        sb.append("<font color=\"#004080\">");
                        sb.append(file.getAbsolutePath() + "\n");
                    }

                    sb.append("</font>");
                    sb.append("</td>\n");

                    sb.append("<td>\n");

                    java.util.Date fileDate = new java.util.Date(file.lastModified());
                    String lastModified =
                        java
                            .text
                            .DateFormat
                            .getDateTimeInstance(
                                java.text.DateFormat.SHORT,
                                java.text.DateFormat.SHORT,
                                java.util.Locale.GERMAN)
                            .format(fileDate);

                    sb.append(lastModified);
                    sb.append("</td>\n");

                    sb.append("<td align=\"right\">\n");

                    String fileLen = null;
                    String origLen = new java.lang.Long(file.length()).toString();

                    if (origLen.length() > 3) {
                        fileLen =
                            origLen.substring(0, origLen.length() - 3)
                                + " "
                                + origLen.substring(origLen.length() - 3, origLen.length());
                    } else
                        fileLen = origLen;

                    sb.append(fileLen);
                    sb.append("</td>\n");

                    curBG = !curBG;

                    sb.append("</tr>\n");

                    } //enf if  (ext.equals("jar")  || (ext.equals("zip")

                } // end for
            } // end for
            sb.append("</table>\n");

        }else{
          sb.append("<br>");
          sb.append("No any archive files matched to your parameters are found");
          sb.append("<br>");
        }// end if alAllFiles != 0
            sb.append("<br>");
            sb.append("<img width=\"12\" height=\"12\" border=0 ");
            sb.append("src=\"");

            for (int i = 0; i < colFlash + 1; i++) {
                sb.append("../");
            }
            sb.append("images/goto.gif\" ");
            sb.append("alt=\"go to\">");
            sb.append(" - link to open according file ");

            sb.append("<br>");

        sb.append("<br>");
        sb.append(
                "<b> Helicon System Analyzer (c) 2002 <a href=\"http://helicon.com.ua\">Helicon Co</a>, Ukraine \n</b>");
        sb.append("<br>");
        sb.append(
                "<b> e-mail: <a href=\"mailto:mail@helicon.com.ua\">mail@helicon.com.ua</a> </b>");

            sb.append("</BODY>\n");
            sb.append("</HTML>\n");

            out.println(sb.toString());

            out.flush();
            out.close();

        }
            public void resort(java.util.ArrayList alForSort, java.util.Comparator comparator) throws java.lang.IllegalArgumentException {

        if (comparator == null) {
            System.out.println("resort(java.util.Comparator) called without comparator");
            throw new java.lang.IllegalArgumentException("resort(java.util.Comparator) called without comparator");
        }
        if (alForSort == null) {
            System.out.println("resort(java.util.Comparator) data not stored");
            throw new java.lang.IllegalArgumentException("resort(java.util.Comparator) data not stored");
        }

        java.util.Collections.sort(alForSort, comparator);

    }

        }