package com.helicon.sysanalyzer;

import java.io.*;
import java.util.*;
import java.util.zip.*;

/**
 * This is the class for creating the ZIP file
 * @author Vladimir Koval &lt;<a href="mailto:kovvl@yahoo.com">kovvl@yahoo.com</a>&gt;
 * @author (c) 2002 Helicon, Ukraine www.helicon.com.ua
**/
public class ZipCreate {

	private ZipOutputStream zip;
	private String rootDir = null;
	private String zipName = null;
	private String zipNameClear = null;
	private boolean verbose = false;


/**
 * Creates a new instance of the ZipCreate class
 *
**/
public ZipCreate(){

	zipName = "testZip.zip";
	try{
    	zip = new ZipOutputStream(new	FileOutputStream(zipName));
	}catch(java.io.FileNotFoundException e){}
    System.out.println(zipName + " created.");

}
/**
 * Creates a new instance of the ZipCreate class
 * @param outputPath String the name of output path for ZIP file
 * @param verbose boolean the verbose mode on
 *
**/
public ZipCreate(String outputPath, boolean verbose, String dateRootDir){


	rootDir = outputPath;
	System.out.println();
	System.out.println("Creating ZIP file");

	this.verbose = verbose;

	String ttime = null;

	if ((outputPath == null) || (outputPath.length() == 0)){
		outputPath += ".\\";
	}

//	if (!outputPath.endsWith("\\")){
//		outputPath += "\\";
	if (!outputPath.endsWith(java.io.File.separator)){
		outputPath += java.io.File.separator;

	}
		// get current time
        zipNameClear = "SystemAnalyzer"+dateRootDir+".zip";
		//define zip name
	    zipName = outputPath+"SystemAnalyzer"+dateRootDir+".zip";

		//int pointInt = outputPath.lastIndexOf("\\", outputPath.length());
		int pointInt = outputPath.lastIndexOf(java.io.File.separator, outputPath.length());

		new java.io.File(outputPath.substring(0, pointInt)).mkdirs();

      try{
	      zip = new ZipOutputStream(new	FileOutputStream(zipName));
      }catch (java.io.FileNotFoundException e){}
      System.out.println(zipName + " created.");


}
/**
* The method for finall events
**/
public void finallyMethod(){

	try{
		zip.close();
	}catch(java.io.IOException e){}

	System.out.println(zipNameClear + " closed.");

}
   /**
    * main()
    */
   public static void main(String[] args) throws IOException {
      // Create the zip file, using the first command line argument as the
      // file name (clobbering the file if it exists).

      String zipName = args[0];
      ZipOutputStream zip = new ZipOutputStream(new
	  FileOutputStream(zipName));
      System.out.println(zipName + " created.");

      try {
         // Allocate a buffer for reading the input files.

         byte[] buffer = new byte[1024];
         int bytesRead;

         // Loop through the file names provided on the command-line.

         for (int i = 1; i < args.length; i ++) {
            // Get the file name.

            String fileName = args[i];

            try {
               // Open the file.

               FileInputStream file = new FileInputStream(fileName);

               try {
                  // Create a zip entry and add it to the zip.

                  ZipEntry entry = new ZipEntry(fileName);
                  zip.putNextEntry(entry);

                  // Read the file the file and write it to the zip.

                  while ((bytesRead = file.read(buffer)) != -1) {
                     zip.write(buffer, 0, bytesRead);
                  }

                  System.out.println(entry.getName() + " added.");
               }
               catch (Exception ex) {
                  System.out.println(ex);
               }
               finally {
                  file.close();
               }
            }
            catch (IOException ex) {
               System.out.println(ex);
            }
         }
      }
      finally {
         zip.close();
         System.out.println(zipName + " closed.");
      }

   }
 /**
   * The main method for creating the ZIP file
   * @param fileName String the name of ZIP file
   * @exception java.io.IOException
   **/
   public void zipCreate(String fileName) throws IOException {
      // Create the zip file, using the first command line argument as the
      // file name (clobbering the file if it exists).
		String clearFileName = null;

		if (rootDir.length() == 0){
			rootDir += ".\\";
		}
		if ( !rootDir.endsWith(java.io.File.separator) ) rootDir += java.io.File.separator;

		if (rootDir.length()>1){
		 clearFileName = fileName.substring(rootDir.length(),fileName.length());
		}else {
		 clearFileName = fileName;
		}


         byte[] buffer = new byte[1024];
         int bytesRead;

         // Loop through the file names provided on the command-line.

            try {
               // Open the file.

               FileInputStream file = new FileInputStream(fileName);

               try {
                  // Create a zip entry and add it to the zip.

                  ZipEntry entry = new ZipEntry(clearFileName);
                  zip.putNextEntry(entry);

                  // Read the file the file and write it to the zip.

                  while ((bytesRead = file.read(buffer)) != -1) {
                     zip.write(buffer, 0, bytesRead);
	              }
				  if (verbose) System.out.println(entry.getName() + " added.");
               }
               catch (Exception ex) {
                  System.out.println(ex);
               }
               finally {
                  file.close();
               }
            }
            catch (IOException ex) {
               System.out.println(ex);
            }
   }
}
